/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#include "audio_gui.h"

#include <gtk/gtk.h>

#include "soundcard.h"

#ifndef WIN

unsigned int audio_gui_register_callback(int mode, void (*fn)(void))
{
  if (mode == PLAY_SOUND)
    return gtk_input_add_full(get_sound_fd(), GDK_INPUT_WRITE, (GdkInputFunction)fn, 0, 0, 0);

  return gtk_input_add_full(get_sound_fd(), GDK_INPUT_READ, (GdkInputFunction)fn, 0, 0, 0);
}

void audio_gui_unregister_callback(unsigned int d)
{
  gtk_input_remove(d);
}

#else /* WIN */

/* these are accessed in soundcard.c */
void (*play_ready)(void);
void (*record_ready)(void);

unsigned int audio_gui_register_callback(int mode, void (*fn)(void))
{
  if (mode == PLAY_SOUND) {
    play_ready = fn;
    return 0;
  }

  record_ready = fn;
  return 1;
}

void audio_gui_unregister_callback(unsigned int d)
{
  if (!d)
    play_ready = 0;
  else
    record_ready = 0;
}

#endif /* WIN */
