/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#ifndef _EQ_H_
#define _EQ_H_

#include "channel.h"
#include "eq_gui.h"

/* window types */
#define EQ_SQUARE	0
#define EQ_BARTLETT	1
#define EQ_BLACKMAN	2
#define EQ_HAMMING	3
#define EQ_HANNING	4

typedef struct eq {
  channel_common c;
  eq_gui gui;
  char *code;
  double fir[256];
  double delay_left[256];
  int pos_in_delay_left;
  double delay_right[256];
  int pos_in_delay_right;
  int fir_length;
  int window_type;
} eq;

eq *new_eq(channel *c);
void delete_eq(eq *);
void run_code_eq(eq *);

#endif /* _EQ_H_ */
