/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#include <gtk/gtk.h>
#include "eq_gui.h"

#include "channel.h"
#include "eq.h"
#include "effects_gui.h"
#include <string.h>
#include <stdlib.h>



static eq_help vh;

static void show_eq_help(void)
{
  if (vh.shown) return;
  init_eq_help(&vh);
  vh.shown = 1;
  gtk_widget_show_all(vh.win);
}

static void hide_eq_help(void)
{
  if (!vh.shown) return;
  gtk_widget_destroy(vh.win);
  vh.shown = 0;
}

void force_redraw_eq(eq *e)
{
  gtk_widget_queue_draw(e->gui.wanted);
  gtk_widget_queue_draw(e->gui.obtained);
}

void eq_open_gui(eq *e, int track_number)
{
  if (e->c.gui_on)
    return;

  if (init_eq_gui(&e->gui, e) == -1)
    return;

  gtk_widget_show_all(e->gui.win);

  e->c.gui_on = 1;

  {
    char t[64];
    sprintf(t, "# %d", track_number+1);
    gtk_label_set_text(GTK_LABEL(e->c.label), t);
  }
}

/* return 0 if no modification in the code, 1 if some */
int save_code_from_gui(eq *e)
{
  GtkTextBuffer *b;
  GtkTextIter start, end;
  char *t;

  /* no gui => no modif */
  if (!e->c.gui_on) return 0;

  b = gtk_text_view_get_buffer(
      GTK_TEXT_VIEW(e->gui.user_code));

  gtk_text_buffer_get_start_iter(b, &start);
  gtk_text_buffer_get_end_iter(b, &end);

  t = gtk_text_buffer_get_text(b, &start, &end, FALSE);

  /* same text => no modif */
  if (e->code && !strcmp(e->code, t))
    return 0;

  /* different text => modif and return 1 */
  if (e->code) free(e->code);

  e->code = t;

  return 1;
}

void eq_close_gui(eq *e)
{
  if (!e->c.gui_on)
    return;

  if (save_code_from_gui(e))
    run_code_eq(e);

  e->c.gui_on = 0;
  e->c.label = 0;

  gtk_widget_destroy(e->gui.win);
}

void hide_error_eq(eq *e)
{
  if (!e->c.gui_on)
    return;

  gtk_label_set_text(GTK_LABEL(e->gui.error), "");
}

void show_error_eq(eq *e, char *c)
{
  if (!e->c.gui_on)
    return;

  if (!c) c = "Error in your code.";

  gtk_label_set_text(GTK_LABEL(e->gui.error), c);
}


static gboolean _1(GtkWidget *_widget, GdkEvent *_event, eq_gui *this)
{
{
    if (!this->c->c.gui_on)
      return TRUE;

    if (save_code_from_gui(this->c))
      run_code_eq(this->c);

    this->c->c.gui_on = 0;
    this->c->c.label = 0;

    effects_gui_force_redraw();

    gtk_widget_destroy(this->win);
  }
  return TRUE;
}

static void _3(GtkButton *_widget, eq_gui *this)
{
  {
    /* we always want to call run_code_eq, the user says so... */
    save_code_from_gui(this->c);
    run_code_eq(this->c);
  }
}

static gboolean _4(GtkWidget *_widget, GdkEventExpose *_event, eq_gui *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  {
    int i;

    /* avoid gcc warnings */
    if (0) { width++; height++; x++; y++; }

    for (i = 0; i < 255; i++)
      gdk_draw_line(((GtkWidget *)this->wanted)->window,
          ((GtkWidget *)this->wanted)->style->fg_gc[GTK_STATE_NORMAL],
          i, this->wanted_values[i],
          i+1, this->wanted_values[i+1]);
  }
  return TRUE;
}

static gboolean _5(GtkWidget *_widget, GdkEventExpose *_event, eq_gui *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  {
    int i;

    /* avoid gcc warnings */
    if (0) { width++; height++; x++; y++; }

    for (i = 0; i < 255; i++)
      gdk_draw_line(((GtkWidget *)this->obtained)->window,
          ((GtkWidget *)this->obtained)->style->fg_gc[GTK_STATE_NORMAL],
          i, this->obtained_values[i],
          i+1, this->obtained_values[i+1]);
  }
  return TRUE;
}

static void _7(GtkButton *_widget, eq_gui *this)
{
  {show_eq_help();}
}

/* returns -1 on error, 0 if everything is fine */
int init_eq_gui(eq_gui *this, struct eq *c)
{
  GtkWidget *_0;
  GtkWidget *_16;
  GtkWidget *run;
  GtkWidget *_2;
  GtkWidget *wanted_label;
  GtkWidget *obtained_label;
  GtkWidget *title_label;
  GtkWidget *help;
  GtkWidget *_6;
  GtkWidget *_8;
  GtkWidget *_9;
  GtkWidget *_10;
  GtkWidget *_11;
  GtkWidget *_12;
  GtkWidget *_13;
  GtkWidget *_14;
  GtkWidget *_15;

  {
#if 0
    int i;
    for (i=0; i<256; i++) {
      this->wanted_values[i] = 20;
      this->obtained_values[i] = 20;
    }
#endif
    this-> c = c;
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width(GTK_CONTAINER(this->win), 5);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 5);
  _16 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_16),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_16),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_16),
      GTK_CORNER_TOP_LEFT);
  run = gtk_button_new();
  _2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_2), "_Save and run");
  this->error = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->error), "");
  wanted_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(wanted_label), "Wanted");
  this->wanted = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->wanted, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->wanted, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->wanted, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->wanted, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->wanted, 256, 101);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->wanted, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->wanted, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->wanted, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->wanted, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->wanted, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  obtained_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(obtained_label), "Obtained");
  this->obtained = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->obtained, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->obtained, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->obtained, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->obtained, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->obtained, 256, 101);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->obtained, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->obtained, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->obtained, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->obtained, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->obtained, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  title_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(title_label), "");
  help = gtk_button_new();
  _6 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_6), "_Help");
  _8 = gtk_hbox_new(FALSE, 0);
  _9 = gtk_hbox_new(FALSE, 0);
  _10 = gtk_hbox_new(FALSE, 10);
  _11 = gtk_hbox_new(FALSE, 0);
  _12 = gtk_hbox_new(FALSE, 0);
  _13 = gtk_hbox_new(FALSE, 0);
  _14 = gtk_hbox_new(FALSE, 0);
  _15 = gtk_hbox_new(FALSE, 0);
  this->user_code = gtk_text_view_new();
  gtk_text_buffer_set_text(gtk_text_view_get_buffer(
    GTK_TEXT_VIEW(this->user_code)),
    "fir_length 8;\nrange 0 22050 0;", -1);
  gtk_widget_set_size_request((GtkWidget *)this->user_code, 256, 150);

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_15, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_16), (GtkWidget *)this->user_code);
  gtk_container_add(GTK_CONTAINER(run), (GtkWidget *)_2);
  gtk_container_add(GTK_CONTAINER(help), (GtkWidget *)_6);
  gtk_box_pack_start(GTK_BOX(_8), (GtkWidget *)title_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_9), (GtkWidget *)_16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_10), (GtkWidget *)run, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_10), (GtkWidget *)this->error, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_11), (GtkWidget *)wanted_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_12), (GtkWidget *)this->wanted, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_13), (GtkWidget *)obtained_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_14), (GtkWidget *)this->obtained, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_15), (GtkWidget *)help, FALSE, FALSE, 0);


  this->win_delete = g_signal_connect(this->win, "delete-event", G_CALLBACK(_1), this);

  this->run_clicked = g_signal_connect(run, "clicked", G_CALLBACK(_3), this);

  this->wanted_expose = g_signal_connect(this->wanted, "expose-event", G_CALLBACK(_4), this);

  this->obtained_expose = g_signal_connect(this->obtained, "expose-event", G_CALLBACK(_5), this);

  this->help_clicked = g_signal_connect(help, "clicked", G_CALLBACK(_7), this);

  {
    c->c.label = title_label;
    if (c->code) {
      GtkTextBuffer *b = gtk_text_view_get_buffer(
          GTK_TEXT_VIEW(this->user_code));
      gtk_text_buffer_set_text(b, c->code, -1);
    }
  }

  return 0;
}

static gboolean _18(GtkWidget *_widget, GdkEvent *_event, eq_help *this)
{
{hide_eq_help();}
  return TRUE;
}

static void _20(GtkButton *_widget, eq_help *this)
{
  {hide_eq_help();}
}

/* returns -1 on error, 0 if everything is fine */
int init_eq_help(eq_help *this)
{
  GtkWidget *_17;
  GtkWidget *_23;
  GtkWidget *close;
  GtkWidget *_19;
  GtkWidget *_21;
  GtkWidget *_22;
  GtkWidget *h;

  { this->shown = 0; }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _17 = gtk_vbox_new(FALSE, 0);
  _23 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_23),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_23),
      GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_23),
      GTK_CORNER_TOP_LEFT);
  close = gtk_button_new();
  _19 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_19), "_Close");
  _21 = gtk_hbox_new(FALSE, 0);
  _22 = gtk_hbox_new(FALSE, 0);
  h = gtk_text_view_new();

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_17);
  gtk_box_pack_start(GTK_BOX(_17), (GtkWidget *)_21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_17), (GtkWidget *)_22, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_23), (GtkWidget *)h);
  gtk_container_add(GTK_CONTAINER(close), (GtkWidget *)_19);
  gtk_box_pack_start(GTK_BOX(_21), (GtkWidget *)_23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_22), (GtkWidget *)close, FALSE, FALSE, 0);


  this->win_delete = g_signal_connect(this->win, "delete-event", G_CALLBACK(_18), this);

  this->close_clicked = g_signal_connect(close, "clicked", G_CALLBACK(_20), this);

  {
    float size = 10;
    GtkWidget *t = h;
    GtkTextIter iter;
    GtkTextTagTable *table = gtk_text_tag_table_new();
    GtkTextBuffer *buffer = gtk_text_buffer_new(table);
    gtk_text_view_set_buffer(GTK_TEXT_VIEW(t), buffer);
    gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(t), GTK_WRAP_WORD);
    gtk_text_view_set_editable(GTK_TEXT_VIEW(t), FALSE);
    gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(t), FALSE);
    gtk_text_view_set_pixels_above_lines(GTK_TEXT_VIEW(t), 5);
    gtk_text_view_set_pixels_below_lines(GTK_TEXT_VIEW(t), 5);
    gtk_text_view_set_left_margin(GTK_TEXT_VIEW(t), 10);
    gtk_text_view_set_right_margin(GTK_TEXT_VIEW(t), 10);
    /* not fucking supported yet. SO DON'T FUCKING PROVIDE THE OPTION! */
    /*gtk_text_view_set_justification(GTK_TEXT_VIEW(t), GTK_JUSTIFY_FILL);*/
    gtk_widget_set_size_request(t, 400, 300);
    gtk_text_buffer_create_tag(buffer, "b",
        "weight", PANGO_WEIGHT_BOLD,
        0);
    gtk_text_buffer_create_tag(buffer, "p",
        "size", (int)(size * PANGO_SCALE),
        //"pixels_above_lines", 20,
        0);
    gtk_text_buffer_create_tag(buffer, "h1",
        "justification", GTK_JUSTIFY_CENTER,
        "weight", PANGO_WEIGHT_BOLD,
        "size", (int)(size * 1.6 * PANGO_SCALE),
        0);
    gtk_text_buffer_create_tag(buffer, "h2",
        "weight", PANGO_WEIGHT_BOLD,
        "size", (int)(size * 1.4 * PANGO_SCALE),
        0);
    gtk_text_buffer_create_tag(buffer, "h3",
        "weight", PANGO_WEIGHT_BOLD,
        "size", (int)(size * 1.2 * PANGO_SCALE),
        0);
    gtk_text_buffer_get_iter_at_offset (buffer, &iter, 0);
#include "eq_help.h"
  }

  return 0;
}

