#include "fft.c"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define FFT_LENGTH	4096

double signal[FFT_LENGTH];
complex ft[FFT_LENGTH];
complex ift[FFT_LENGTH];

/*
 real signal => fft[i].re = fft[4096-i].re
                fft[i].im = -fft[4096-1].im
                with 2048 < i < 4096
 */
#if 0
/* some stuff to understand fft */
int main(void)
{
  int i;
  fft f;
  open_fft(&f, FFT_LENGTH);

  for (i=0; i<FFT_LENGTH; i++)
    //signal[i] = cos (2 * M_PI * i * 441/44100);
    signal[i] = rand();

  fft_double(&f, signal, ft);

  for (i=0; i<FFT_LENGTH; i++)
    //printf("%d %g\n", i, signal[i]);
    printf("%d %g\n", i, sqrt(ft[i].re*ft[i].re+ft[i].im*ft[i].im));

  return 0;
}
#endif

/* some stuff to understand ifft */
int main(void)
{
  int i;
  fft f;
  open_fft(&f, FFT_LENGTH);

  for (i=0; i<FFT_LENGTH; i++)
    ft[i].re = 1, ft[i].im = 0;

  for (i=0; i<100; i++) ft[i].re = 0;

  for (i=FFT_LENGTH/2+1; i < FFT_LENGTH; i++) {
    ft[i].re = ft[FFT_LENGTH-i].re;
    ft[i].im = -ft[FFT_LENGTH-i].im;
  }

  ifft_double(&f, ft, ift);

//#define D(i) (sqrt(ift[i].re*ift[i].re+ift[i].im*ift[i].im))
#define D(i) (ift[i].re)
  for (i=0; i<FFT_LENGTH; i++) signal[i] = 0;
  signal[0] = D(4090);
  signal[1] = D(4091);
  signal[2] = D(4092);
  signal[3] = D(4093);
  signal[4] = D(4094);
  signal[5] = D(4095);
  signal[6] = D(0);
  signal[7] = D(1);
  signal[8] = D(2);
  signal[9] = D(3);
  signal[10] = D(4);
#if 0
  signal[6] = signal[5];
  signal[7] = signal[4];
  signal[8] = signal[3];
  signal[9] = signal[2];
  signal[10] = signal[1];
  signal[11] = signal[0];
#endif

  fft_double(&f, signal, ft);

  for (i=0; i<FFT_LENGTH; i++) {
    double v = sqrt(ft[i].re*ft[i].re+ft[i].im*ft[i].im);
    printf("%d %g\n", i, 20*log10(v));
  }

  return 0;
}
