/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#ifndef _VERB_H_
#define _VERB_H_

#include "channel.h"
#include "verb_gui.h"
#include "sverb.h"

typedef struct verb {
  channel_common c;
  verb_gui gui;
  sverb s_left;
  sverb s_right;
  double level_reverb;
  double level_signal;
  int left_delay;
  int right_delay;
  double l_delay[256];
  double r_delay[256];
  int left_cur;
  int right_cur;
  int last_point;
  int sub_last_point;
} verb;

verb *new_verb(channel *c);
void delete_verb(verb *);

#endif /* _VERB_H_ */
