/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#include <gtk/gtk.h>
#include "verb_gui.h"

#include "channel.h"
#include "verb.h"
#include "effects_gui.h"
#include <stdlib.h>



static verb_help vh;

static void show_verb_help(void)
{
  if (vh.shown) return;
  init_verb_help(&vh);
  vh.shown = 1;
  gtk_widget_show_all(vh.win);
}

static void hide_verb_help(void)
{
  if (!vh.shown) return;
  gtk_widget_destroy(vh.win);
  vh.shown = 0;
}

void from_verb_to_gui(verb *e)
{
  char t[64*16];

  /* set delay (left and right are same, so use left) */
  sprintf(t, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
          e->s_left.DELAY[0], e->s_left.DELAY[1], e->s_left.DELAY[2],
          e->s_left.DELAY[3], e->s_left.DELAY[4], e->s_left.DELAY[5],
          e->s_left.DELAY[6], e->s_left.DELAY[7], e->s_left.DELAY[8],
          e->s_left.DELAY[9], e->s_left.DELAY[10], e->s_left.DELAY[11],
          e->s_left.DELAY[12], e->s_left.DELAY[13], e->s_left.DELAY[14]);
  gtk_entry_set_text(GTK_ENTRY(e->gui.delay), t);

  /* set t60 */
  sprintf(t, "%g %g", e->s_left.t60_0, e->s_left.t60_pi);
  gtk_entry_set_text(GTK_ENTRY(e->gui.t60), t);

  /* set level */
  sprintf(t, "%g", e->level_reverb);
  gtk_entry_set_text(GTK_ENTRY(e->gui.level_reverb), t);

  sprintf(t, "%g", e->level_signal);
  gtk_entry_set_text(GTK_ENTRY(e->gui.level_signal), t);

  /* set int precision */
  sprintf(t, "%d", e->s_left.integer_precision);
  gtk_entry_set_text(GTK_ENTRY(e->gui.int_precision), t);

  /* set type */
  switch (e->s_left.type) {
    case SVERB_FLOAT:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(e->gui.use_float), TRUE);
      break;
    case SVERB_INT:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(e->gui.use_int), TRUE);
      break;
#ifdef ASM_IA32
    case SVERB_ASM:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(e->gui.use_asm), TRUE);
      break;
#endif
    default: /* do nothing */ break;
  }

  /* set bypass t60 */
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(e->gui.bypass_t60),
                               e->s_left.bypass_t60 ? TRUE : FALSE);

  /* set left/right delay */
  sprintf(t, "%d", e->left_delay);
  gtk_entry_set_text(GTK_ENTRY(e->gui.left_delay), t);

  sprintf(t, "%d", e->right_delay);
  gtk_entry_set_text(GTK_ENTRY(e->gui.right_delay), t);
}

void verb_open_gui(verb *e, int track_number)
{
  if (e->c.gui_on)
    return;

  if (init_verb_gui(&e->gui, e) == -1)
    return;

  gtk_widget_show_all(e->gui.win);

  e->c.gui_on = 1;

  {
    char t[64];
    sprintf(t, "# %d", track_number+1);
    gtk_label_set_text(GTK_LABEL(e->c.label), t);
  }

  from_verb_to_gui(e);
}

void verb_close_gui(verb *e)
{
  if (!e->c.gui_on)
    return;

  save_reverb_from_gui(e);

  e->c.gui_on = 0;
  e->c.label = 0;

  gtk_widget_destroy(e->gui.win);
}

/* we should handle errors more gracefully, here it's no message at
 * all, it's bad
 */
void save_reverb_from_gui(verb *e)
{
  int d[15];
  int i;
  const char *t;
  float t60_0, t60_pi;
  int delay_err;

  /*  no gui, no modif */
  if (!e->c.gui_on) return;

  /* let's free previous reverb */
  sverb_free(&e->s_left);
  sverb_free(&e->s_right);

  /* set type */
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(e->gui.use_float))) {
    sverb_set_type(&e->s_left, SVERB_FLOAT);
    sverb_set_type(&e->s_right, SVERB_FLOAT);
  }
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(e->gui.use_int))) {
    sverb_set_type(&e->s_left, SVERB_INT);
    sverb_set_type(&e->s_right, SVERB_INT);
  }
#ifdef ASM_IA32
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(e->gui.use_asm))) {
    sverb_set_type(&e->s_left, SVERB_ASM);
    sverb_set_type(&e->s_right, SVERB_ASM);
  }
#endif

  /* store delays */
  delay_err = 0;
  t = gtk_entry_get_text(GTK_ENTRY(e->gui.delay));
  if (sscanf(t, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
             &d[0], &d[1], &d[2], &d[3], &d[4], &d[5], &d[6], &d[7],
             &d[8], &d[9], &d[10], &d[11], &d[12], &d[13],
             &d[14]) == 15) {
    for (i = 0; i < 15; i++) {
      if (d[i] < 1) d[i] = 1;
      if (d[i] > 1000000) d[i] = 1000000;
      if (d[i] != e->s_left.DELAY[i]) {
        if (sverb_set_delay(&e->s_left, i, d[i]) == -1) delay_err = 1;
        if (sverb_set_delay(&e->s_right, i, d[i]) == -1) delay_err = 1;
      }
    }
  }

  /* t60 */
  t = gtk_entry_get_text(GTK_ENTRY(e->gui.t60));
  if (sscanf(t, "%g %g", &t60_0, &t60_pi) == 2) {
    /* don't know what values are ok, let's force 1e-10 -> 1e10 */
    if (t60_0 < 1e-10) t60_0 = 1e-10;
    if (t60_0 > 1e10) t60_0 = 1e10;
    if (t60_pi < 1e-10) t60_pi = 1e-10;
    if (t60_pi > 1e10) t60_pi = 1e10;
    sverb_set_t60(&e->s_left, t60_0, t60_pi);
    sverb_set_t60(&e->s_right, t60_0, t60_pi);
  }

  /* level */
  t = gtk_entry_get_text(GTK_ENTRY(e->gui.level_reverb));
  if (sscanf(t, "%lg", &e->level_reverb) == 1) {
    if (e->level_reverb < 0) e->level_reverb = 0;
    if (e->level_reverb > 1000) e->level_reverb = 1000;
  }

  t = gtk_entry_get_text(GTK_ENTRY(e->gui.level_signal));
  if (sscanf(t, "%lg", &e->level_signal) == 1) {
    if (e->level_signal < 0) e->level_signal = 0;
    if (e->level_signal > 1000) e->level_signal = 1000;
  }

  /* int precision */
  t = gtk_entry_get_text(GTK_ENTRY(e->gui.int_precision));
  if (sscanf(t, "%d", &d[0]) == 1) {
    if (d[0] < 2) d[0] = 2;
    if (d[0] > 30)  d[0] = 30;
    sverb_set_integer_precision(&e->s_left, d[0]);
    sverb_set_integer_precision(&e->s_right, d[0]);
  }

  /* bypass t60 */
  sverb_use_t60(&e->s_left,
    !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(e->gui.bypass_t60)));
  sverb_use_t60(&e->s_right,
    !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(e->gui.bypass_t60)));

  /* left/right delay */
  t = gtk_entry_get_text(GTK_ENTRY(e->gui.left_delay));
  if (sscanf(t, "%d", &d[0]) == 1) {
    if (d[0] < 0) d[0] = 0;
    if (d[0] > 255) d[0] = 255;
    e->left_delay = d[0];
  }

  t = gtk_entry_get_text(GTK_ENTRY(e->gui.right_delay));
  if (sscanf(t, "%d", &d[0]) == 1) {
    if (d[0] < 0) d[0] = 0;
    if (d[0] > 255) d[0] = 255;
    e->right_delay = d[0];
  }

  /* some malloc error? free all (we should warn the user) */
  if (delay_err) {
    sverb_free(&e->s_left);
    sverb_free(&e->s_right);
  }
}

void set_verb(verb *e, int type)
{
  static int delays[][15] = {
    /* tiny */
    { 42, 29, 26, 23, 21, 19, 18, 17, 16, 15, 14, 13, 11, 9, 7 },
    /* small 1 */
    {1, 2, 109, 107, 5, 6, 7, 19, 29, 10, 137, 12, 13, 191, 15},
    /* small 2 */
    {15, 14, 113, 12, 11, 10, 59, 8, 7, 233, 97, 4, 29, 2, 89},
    /* medium 1 */
    {907, 777, 631, 313, 211, 137, 107, 99, 69, 43, 21, 13, 11, 9, 3},
    /* medium 2 */
    {197, 179, 113, 163, 199, 29, 379, 137, 103, 457, 389, 23, 97, 653, 223},
    /* normal 1 */
    {2207, 223, 307, 59, 647, 149, 359, 83, 127, 613, 593, 61, 337, 53, 877},
    /* normal 2 */
    {157, 17, 113, 313, 613, 1823, 521, 1523, 107, 73, 61, 853, 269, 281, 31},
    /* normal 3 */
    {733, 317, 367, 541, 401, 139, 379, 607, 233, 727, 467, 263, 163, 929,
     443},
    /* middle */
    {3407, 2551, 2053, 1867, 1009, 641, 367, 313, 269, 113, 53, 43, 37,
     29, 19},
    /* large 1 */
    {1627, 401, 577, 6563, 1319, 3691, 1259, 2203, 3511, 1187, 673, 809,
     4211, 4889, 163},
    /* large 2 */
    {2647, 1373, 1993, 2909, 2111, 1901, 2423, 2789, 1439, 2459, 1931,
     2179, 1907, 2633, 2437},
    /* big 1 */
    {2011, 1901, 3527, 7283, 4099, 4463, 3821, 5189, 3581, 8419, 5323,
     8707, 3407, 3727, 691},
    /* big 2 */
    {4903, 4243, 3733, 5557, 4127, 4441, 5419, 6211, 3299, 4229, 3631,
     3727, 3907, 4079, 4673},
    /* huge */
    {2153, 7411, 487, 10559, 15233, 8209, 2069, 8387, 10627, 18041,
     14447, 20743, 2063, 8951, 3943}
  };
  static float t60_0s[] = {
    0.04,
    0.1,
    0.1,
    0.5,
    0.5,
    1.,
    1.,
    1.,
    2.,
    5.,
    5.,
    10.,
    10.,
    20.
  };
  static float t60_pis[] = {
    0.02,
    0.05,
    0.05,
    0.25,
    0.25,
    0.5,
    0.5,
    0.5,
    1.,
    2.5,
    2.5,
    5.,
    5.,
    10.
  };
  int i;

  /* if gui open, get values from gui */
  save_reverb_from_gui(e);

  /* free old reverb buffers */
  for (i = 0; i < 15; i++) {
    if (e->s_left.delays[i]) free(e->s_left.delays[i]);
    e->s_left.delays[i] = 0;
    if (e->s_left.delays_int[i]) free(e->s_left.delays_int[i]);
    e->s_left.delays_int[i] = 0;

    if (e->s_right.delays[i]) free(e->s_right.delays[i]);
    e->s_right.delays[i] = 0;
    if (e->s_right.delays_int[i]) free(e->s_right.delays_int[i]);
    e->s_right.delays_int[i] = 0;
  }

  /* get new delays */
  for (i = 0; i < 15; i++)
    if (sverb_set_delay(&e->s_left, i, delays[type][i]) == -1) i = 100;

  if (i != 100) for (i = 0; i < 15; i++)
    if (sverb_set_delay(&e->s_right, i, delays[type][i]) == -1) i = 100;

  /* in case of problem, free all and return */
  if (i == 100) {
    for (i = 0; i < 15; i++) {
      if (e->s_left.delays[i]) free(e->s_left.delays[i]);
      e->s_left.delays[i] = 0;
      if (e->s_left.delays_int[i]) free(e->s_left.delays_int[i]);
      e->s_left.delays_int[i] = 0;

      if (e->s_right.delays[i]) free(e->s_right.delays[i]);
      e->s_right.delays[i] = 0;
      if (e->s_right.delays_int[i]) free(e->s_right.delays_int[i]);
      e->s_right.delays_int[i] = 0;
    }
    return;
  }

  /* set t60 */
  sverb_set_t60(&e->s_left, t60_0s[type], t60_pis[type]);
  sverb_set_t60(&e->s_right, t60_0s[type], t60_pis[type]);

  sverb_reset(&e->s_left);
  sverb_reset(&e->s_right);

  if (e->c.gui_on)
    from_verb_to_gui(e);
}


static gboolean _1(GtkWidget *_widget, GdkEvent *_event, verb_gui *this)
{
{
    if (!this->c->c.gui_on)
      return TRUE;

    save_reverb_from_gui(this->c);

    this->c->c.gui_on = 0;
    this->c->c.label = 0;

    effects_gui_force_redraw();

    gtk_widget_destroy(this->win);
  }
  return TRUE;
}

static void _7(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_TINY);}
}

static void _9(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_SMALL_1);}
}

static void _11(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_SMALL_2);}
}

static void _13(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_MEDIUM_1);}
}

static void _15(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_MEDIUM_2);}
}

static void _17(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_AVERAGE_1);}
}

static void _19(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_AVERAGE_2);}
}

static void _21(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_AVERAGE_3);}
}

static void _23(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_MIDDLE);}
}

static void _25(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_LARGE_1);}
}

static void _27(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_LARGE_2);}
}

static void _29(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_BIG_1);}
}

static void _31(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_BIG_2);}
}

static void _33(GtkButton *_widget, verb_gui *this)
{
  {set_verb(this->c, SVERB_HUGE);}
}

static void _35(GtkButton *_widget, verb_gui *this)
{
  {
    save_reverb_from_gui(this->c);
    from_verb_to_gui(this->c);
  }
}

static void _37(GtkButton *_widget, verb_gui *this)
{
  {show_verb_help();}
}

/* returns -1 on error, 0 if everything is fine */
int init_verb_gui(verb_gui *this, struct verb *c)
{
  GtkWidget *_0;
  GtkWidget *title_label;
  GtkWidget *delay_label;
  GtkWidget *t60_label;
  GtkWidget *level_reverb_label;
  GtkWidget *level_signal_label;
  GtkWidget *int_precision_label;
  GtkWidget *_2;
  GtkWidget *_3;
  GtkWidget *_4;
  GtkWidget *_5;
  GtkWidget *left_delay_label;
  GtkWidget *right_delay_label;
  GtkWidget *tiny;
  GtkWidget *_6;
  GtkWidget *small1;
  GtkWidget *_8;
  GtkWidget *small2;
  GtkWidget *_10;
  GtkWidget *medium1;
  GtkWidget *_12;
  GtkWidget *medium2;
  GtkWidget *_14;
  GtkWidget *average1;
  GtkWidget *_16;
  GtkWidget *average2;
  GtkWidget *_18;
  GtkWidget *average3;
  GtkWidget *_20;
  GtkWidget *middle;
  GtkWidget *_22;
  GtkWidget *large1;
  GtkWidget *_24;
  GtkWidget *large2;
  GtkWidget *_26;
  GtkWidget *big1;
  GtkWidget *_28;
  GtkWidget *big2;
  GtkWidget *_30;
  GtkWidget *huge;
  GtkWidget *_32;
  GtkWidget *save;
  GtkWidget *_34;
  GtkWidget *help;
  GtkWidget *_36;
  GtkWidget *_38;
  GtkWidget *_39;
  GtkWidget *_40;
  GtkWidget *_41;
  GtkWidget *_42;
  GtkWidget *_43;
  GtkWidget *_44;
  GtkWidget *_45;
  GtkWidget *_46;
  GtkWidget *_47;
  GtkWidget *_48;
  GtkWidget *_49;
  GtkWidget *_50;
  GtkWidget *_51;
  GtkWidget *_52;

  {
    this-> c = c;
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width(GTK_CONTAINER(this->win), 5);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 5);
  title_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(title_label), "");
  this->delay = gtk_entry_new();
  delay_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(delay_label), "Delay lines");
  this->t60 = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->t60),
    "");
  t60_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(t60_label), "T60 (0 and PI)");
  this->level_reverb = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->level_reverb),
    "");
  level_reverb_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(level_reverb_label), "Reverb level");
  this->level_signal = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->level_signal),
    "");
  level_signal_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(level_signal_label), "Input level");
  this->int_precision = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->int_precision),
    "");
  int_precision_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(int_precision_label), "Int precision");
  this->use_float = gtk_radio_button_new(0);
  _2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_2), "Float");
  this->use_int = gtk_radio_button_new(0);
  _3 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_3), "Integer");
  this->use_asm = gtk_radio_button_new(0);
  _4 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_4), "Asm");
  this->bypass_t60 = gtk_check_button_new();
  _5 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_5), "Bypass t60");
  this->left_delay = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->left_delay),
    "");
  left_delay_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(left_delay_label), "Left delay");
  this->right_delay = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->right_delay),
    "");
  right_delay_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(right_delay_label), "Right delay");
  tiny = gtk_button_new();
  _6 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_6), "tiny");
  small1 = gtk_button_new();
  _8 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_8), "small 1");
  small2 = gtk_button_new();
  _10 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_10), "small 2");
  medium1 = gtk_button_new();
  _12 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_12), "medium 1");
  medium2 = gtk_button_new();
  _14 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_14), "medium 2");
  average1 = gtk_button_new();
  _16 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_16), "average 1");
  average2 = gtk_button_new();
  _18 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_18), "average 2");
  average3 = gtk_button_new();
  _20 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_20), "average 3");
  middle = gtk_button_new();
  _22 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_22), "middle");
  large1 = gtk_button_new();
  _24 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_24), "large 1");
  large2 = gtk_button_new();
  _26 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_26), "large 2");
  big1 = gtk_button_new();
  _28 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_28), "big 1");
  big2 = gtk_button_new();
  _30 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_30), "big 2");
  huge = gtk_button_new();
  _32 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_32), "huge");
  save = gtk_button_new();
  _34 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_34), "_Save");
  help = gtk_button_new();
  _36 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_36), "_Help");
  _38 = gtk_hbox_new(FALSE, 0);
  _39 = gtk_hbox_new(FALSE, 5);
  _40 = gtk_hbox_new(FALSE, 5);
  _41 = gtk_hbox_new(FALSE, 5);
  _42 = gtk_hbox_new(FALSE, 5);
  _43 = gtk_hbox_new(FALSE, 5);
  _44 = gtk_hbox_new(FALSE, 0);
  _45 = gtk_hbox_new(FALSE, 0);
  _46 = gtk_hbox_new(FALSE, 0);
  _47 = gtk_hbox_new(FALSE, 0);
  _48 = gtk_hbox_new(FALSE, 0);
  _49 = gtk_hbox_new(FALSE, 0);
  _50 = gtk_hbox_new(FALSE, 0);
  _51 = gtk_hbox_new(FALSE, 0);
  _52 = gtk_hbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_49, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_50, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_51, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_52, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(this->use_float), (GtkWidget *)_2);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->use_float),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->use_asm)));
  gtk_container_add(GTK_CONTAINER(this->use_int), (GtkWidget *)_3);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->use_int),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->use_asm)));
  gtk_container_add(GTK_CONTAINER(this->use_asm), (GtkWidget *)_4);
  gtk_container_add(GTK_CONTAINER(this->bypass_t60), (GtkWidget *)_5);
  gtk_container_add(GTK_CONTAINER(tiny), (GtkWidget *)_6);
  gtk_container_add(GTK_CONTAINER(small1), (GtkWidget *)_8);
  gtk_container_add(GTK_CONTAINER(small2), (GtkWidget *)_10);
  gtk_container_add(GTK_CONTAINER(medium1), (GtkWidget *)_12);
  gtk_container_add(GTK_CONTAINER(medium2), (GtkWidget *)_14);
  gtk_container_add(GTK_CONTAINER(average1), (GtkWidget *)_16);
  gtk_container_add(GTK_CONTAINER(average2), (GtkWidget *)_18);
  gtk_container_add(GTK_CONTAINER(average3), (GtkWidget *)_20);
  gtk_container_add(GTK_CONTAINER(middle), (GtkWidget *)_22);
  gtk_container_add(GTK_CONTAINER(large1), (GtkWidget *)_24);
  gtk_container_add(GTK_CONTAINER(large2), (GtkWidget *)_26);
  gtk_container_add(GTK_CONTAINER(big1), (GtkWidget *)_28);
  gtk_container_add(GTK_CONTAINER(big2), (GtkWidget *)_30);
  gtk_container_add(GTK_CONTAINER(huge), (GtkWidget *)_32);
  gtk_container_add(GTK_CONTAINER(save), (GtkWidget *)_34);
  gtk_container_add(GTK_CONTAINER(help), (GtkWidget *)_36);
  gtk_box_pack_start(GTK_BOX(_38), (GtkWidget *)title_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_39), (GtkWidget *)delay_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_39), (GtkWidget *)this->delay, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_40), (GtkWidget *)t60_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_40), (GtkWidget *)this->t60, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_41), (GtkWidget *)level_reverb_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_41), (GtkWidget *)this->level_reverb, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_42), (GtkWidget *)level_signal_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_42), (GtkWidget *)this->level_signal, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_43), (GtkWidget *)int_precision_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_43), (GtkWidget *)this->int_precision, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_44), (GtkWidget *)this->use_float, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_44), (GtkWidget *)this->use_int, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_44), (GtkWidget *)this->use_asm, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_45), (GtkWidget *)this->bypass_t60, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_46), (GtkWidget *)left_delay_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_46), (GtkWidget *)this->left_delay, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_47), (GtkWidget *)right_delay_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_47), (GtkWidget *)this->right_delay, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_48), (GtkWidget *)tiny, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_48), (GtkWidget *)small1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_48), (GtkWidget *)small2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_48), (GtkWidget *)medium1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_48), (GtkWidget *)medium2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_49), (GtkWidget *)average1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_49), (GtkWidget *)average2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_49), (GtkWidget *)average3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_49), (GtkWidget *)middle, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_50), (GtkWidget *)large1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_50), (GtkWidget *)large2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_50), (GtkWidget *)big1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_50), (GtkWidget *)big2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_50), (GtkWidget *)huge, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_51), (GtkWidget *)save, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_52), (GtkWidget *)help, FALSE, FALSE, 0);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(this->use_float), TRUE);


  this->win_delete = g_signal_connect(this->win, "delete-event", G_CALLBACK(_1), this);

  this->tiny_clicked = g_signal_connect(tiny, "clicked", G_CALLBACK(_7), this);

  this->small1_clicked = g_signal_connect(small1, "clicked", G_CALLBACK(_9), this);

  this->small2_clicked = g_signal_connect(small2, "clicked", G_CALLBACK(_11), this);

  this->medium1_clicked = g_signal_connect(medium1, "clicked", G_CALLBACK(_13), this);

  this->medium2_clicked = g_signal_connect(medium2, "clicked", G_CALLBACK(_15), this);

  this->average1_clicked = g_signal_connect(average1, "clicked", G_CALLBACK(_17), this);

  this->average2_clicked = g_signal_connect(average2, "clicked", G_CALLBACK(_19), this);

  this->average3_clicked = g_signal_connect(average3, "clicked", G_CALLBACK(_21), this);

  this->middle_clicked = g_signal_connect(middle, "clicked", G_CALLBACK(_23), this);

  this->large1_clicked = g_signal_connect(large1, "clicked", G_CALLBACK(_25), this);

  this->large2_clicked = g_signal_connect(large2, "clicked", G_CALLBACK(_27), this);

  this->big1_clicked = g_signal_connect(big1, "clicked", G_CALLBACK(_29), this);

  this->big2_clicked = g_signal_connect(big2, "clicked", G_CALLBACK(_31), this);

  this->huge_clicked = g_signal_connect(huge, "clicked", G_CALLBACK(_33), this);

  this->save_clicked = g_signal_connect(save, "clicked", G_CALLBACK(_35), this);

  this->help_clicked = g_signal_connect(help, "clicked", G_CALLBACK(_37), this);

  {
    c->c.label = title_label;
#ifndef ASM_IA32
    gtk_widget_destroy(this->use_asm);
#endif
  }

  return 0;
}

static gboolean _54(GtkWidget *_widget, GdkEvent *_event, verb_help *this)
{
{hide_verb_help();}
  return TRUE;
}

static void _56(GtkButton *_widget, verb_help *this)
{
  {hide_verb_help();}
}

/* returns -1 on error, 0 if everything is fine */
int init_verb_help(verb_help *this)
{
  GtkWidget *_53;
  GtkWidget *_59;
  GtkWidget *close;
  GtkWidget *_55;
  GtkWidget *_57;
  GtkWidget *_58;
  GtkWidget *h;

  { this->shown = 0; }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _53 = gtk_vbox_new(FALSE, 0);
  _59 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_59),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_59),
      GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_59),
      GTK_CORNER_TOP_LEFT);
  close = gtk_button_new();
  _55 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_55), "_Close");
  _57 = gtk_hbox_new(FALSE, 0);
  _58 = gtk_hbox_new(FALSE, 0);
  h = gtk_text_view_new();

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_53);
  gtk_box_pack_start(GTK_BOX(_53), (GtkWidget *)_57, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_53), (GtkWidget *)_58, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_59), (GtkWidget *)h);
  gtk_container_add(GTK_CONTAINER(close), (GtkWidget *)_55);
  gtk_box_pack_start(GTK_BOX(_57), (GtkWidget *)_59, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_58), (GtkWidget *)close, FALSE, FALSE, 0);


  this->win_delete = g_signal_connect(this->win, "delete-event", G_CALLBACK(_54), this);

  this->close_clicked = g_signal_connect(close, "clicked", G_CALLBACK(_56), this);

  {
    float size = 10;
    GtkWidget *t = h;
    GtkTextIter iter;
    GtkTextTagTable *table = gtk_text_tag_table_new();
    GtkTextBuffer *buffer = gtk_text_buffer_new(table);
    gtk_text_view_set_buffer(GTK_TEXT_VIEW(t), buffer);
    gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(t), GTK_WRAP_WORD);
    gtk_text_view_set_editable(GTK_TEXT_VIEW(t), FALSE);
    gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(t), FALSE);
    gtk_text_view_set_pixels_above_lines(GTK_TEXT_VIEW(t), 5);
    gtk_text_view_set_pixels_below_lines(GTK_TEXT_VIEW(t), 5);
    gtk_text_view_set_left_margin(GTK_TEXT_VIEW(t), 10);
    gtk_text_view_set_right_margin(GTK_TEXT_VIEW(t), 10);
    /* not fucking supported yet. SO DON'T FUCKING PROVIDE THE OPTION! */
    /*gtk_text_view_set_justification(GTK_TEXT_VIEW(t), GTK_JUSTIFY_FILL);*/
    gtk_widget_set_size_request(t, 400, 300);
    gtk_text_buffer_create_tag(buffer, "b",
        "weight", PANGO_WEIGHT_BOLD,
        0);
    gtk_text_buffer_create_tag(buffer, "p",
        "size", (int)(size * PANGO_SCALE),
        //"pixels_above_lines", 20,
        0);
    gtk_text_buffer_create_tag(buffer, "h1",
        "justification", GTK_JUSTIFY_CENTER,
        "weight", PANGO_WEIGHT_BOLD,
        "size", (int)(size * 1.6 * PANGO_SCALE),
        0);
    gtk_text_buffer_create_tag(buffer, "h2",
        "weight", PANGO_WEIGHT_BOLD,
        "size", (int)(size * 1.4 * PANGO_SCALE),
        0);
    gtk_text_buffer_create_tag(buffer, "h3",
        "weight", PANGO_WEIGHT_BOLD,
        "size", (int)(size * 1.2 * PANGO_SCALE),
        0);
    gtk_text_buffer_get_iter_at_offset (buffer, &iter, 0);
#include "verb_help.h"
  }

  return 0;
}

