#include <windows.h>
#include <stdio.h>

char buf[4096];

static int thread_id;

void CALLBACK out_handler(HWAVEOUT out, UINT msg, DWORD *inst,
                          DWORD *p1, DWORD *p2)
{
  switch (msg) {
    case WOM_CLOSE:
      printf("close msg\n");
      break;
    case WOM_DONE: {
      printf("done msg\n");
      if (!PostThreadMessage(thread_id, WM_USER, 0, 0)) {
        printf("post message err\n");
        return;
      }
      break;
    }
    case WOM_OPEN: {
      printf("open msg\n");
      if (!PostThreadMessage(thread_id, WM_USER, 0, 0)) {
        printf("post message err\n");
        return;
      }
      break;
    }
    default:
      printf("unknown message %u\n", msg);
      break;
  }
}

int main(void)
{
  FILE *f;
  int n;
  int i;
  WAVEOUTCAPS c;
  HWAVEOUT out;
  WAVEFORMATEX format;
  MSG m;
  int has_audio = 0;
  WAVEHDR h;
  int loop  = 0;

  f = fopen("fuck.pcm", "rb");
  if (f == NULL) exit(0);

  fread(buf, 4096, 1, f);

  thread_id = GetCurrentThreadId();
  /* force windows to create a message queue (hey, I just have troubles
   * with this bullshit, so I try stuff. Maybe it's not necessary but I
   * don't give a shit, it works...
   */
  PeekMessage(&m, NULL, WM_USER, WM_USER, PM_NOREMOVE);

  /* audio out devices? */
  n = waveOutGetNumDevs();
  if (n == 0) {
    printf("no audio card\n");
    return 1;
  }

  /* one that can do 44.1 KHz 16b mono out? */
  for (i=0; i<n; i++) {
    if (waveOutGetDevCaps(i, &c, sizeof(WAVEOUTCAPS)) != MMSYSERR_NOERROR) {
      printf("error\n");
      continue;
    }
    printf("%s %s\n", c.szPname, c.dwFormats & WAVE_FORMAT_4M16 ?
            "can do 16b mono 44.1 KHz out" :
            "cannot do 16b mono 44.1 KHz out");

    if (c.dwFormats & WAVE_FORMAT_4M16)
      has_audio = 1;
  }

  if (!has_audio) {
    printf("no audio found that can do 44.1 KHz 16b mono out\n");
    return 1;
  }

  /* let's open audio for out stuff */
  format.wFormatTag = WAVE_FORMAT_PCM;
  format.nChannels = 1;
  format.nSamplesPerSec = 44100;
  format.nAvgBytesPerSec = 44100 * 2;
  format.nBlockAlign = 2;
  format.wBitsPerSample = 16;
  format.cbSize = 0;
  if (waveOutOpen(&out, WAVE_MAPPER, &format, (unsigned long)out_handler, 0,
                  CALLBACK_FUNCTION) != MMSYSERR_NOERROR) {
    printf("error open audio in\n");
    return 1;
  }

  /* wait for windows to say it's ready */
  if (!(i=GetMessage(&m, (void *)-1, 0, 0))) {
    printf("error with get message\n");
    return 1;
  }
  if (i == -1) {
    printf("getmess error\n");
    return 1;
  }

  h.lpData = buf;
  h.dwBufferLength = 4096;
  h.dwFlags = 0;
  h.dwLoops = 0;
  if (waveOutPrepareHeader(out, &h, sizeof(WAVEHDR)) != MMSYSERR_NOERROR) {
    printf("error prepare header\n");
    return 1;
  }

again:
  if (waveOutWrite(out, &h, sizeof(WAVEHDR)) != MMSYSERR_NOERROR) {
    printf("error with get message\n");
    return 1;
  }

 /* wait */
  if (!(i=GetMessage(&m, (void *)-1, 0, 0))) {
    printf("error with get message\n");
    return 1;
  }
  printf("message!\n");

  fread(buf, 4096, 1, f);

  loop++;
  if (loop < 100) goto again;

  if (fclose(f) == -1) {
    printf("error close f\n");
    exit(1);
  }

  return 0;
}
